%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function 'pac' creates simple .avi file which contains motion of a small pacman, 
% Programed by xiangdong wen
% Date : Oct, 2002
% Advisor : Dr.Longin Jan Latecki (latecki@temple.edu )
% Project : a small movie
% 
% Input arguments: No need for input
% Output : 'pacman.avi'
% Example : pac()
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pac()

global aviobj;
aviobj= avifile('pacman.avi','fps',12); % initialize .avi file object.
 
global bigMatrixImg;

%initial the image matrix
bigMatrixImg=zeros(240,320,3);

%Draw the track of the road
for j=0:1:3
    for i1=-1+j:1:7-j
        for k1=1:1:40
            if(i1*40+k1>0)
            bigMatrixImg(j*40+1,i1*40+k1,2)=1;
            bigMatrixImg(j*40+2,i1*40+k1,2)=1;
            end
        end    
    end

 if (j==3)break;end;
 for i2=j:1:5-j
    for k1=1:1:40
        bigMatrixImg(i2*40+k1,(8-j)*40-1,2)=1;
        bigMatrixImg(i2*40+k1,(8-j)*40-2,2)=1;   
    end   
 end
 for i3=8-j:-1:1+j
    for k1=1:1:40
        bigMatrixImg((6-j)*40-1,(i3)*40-k1+1,2)=1;
        bigMatrixImg((6-j)*40-2,(i3)*40-k1+1,2)=1;
    end   
 end
 for i4=6-j:-1:2+j
      for k1=1:1:40
        bigMatrixImg((i4)*40-k1+1,(j)*40+1,2)=1;
        bigMatrixImg((i4)*40-k1+1,(j)*40+2,2)=1;
    end     
 end
end

%Draw the food on the road

 for j=0:1:2
for i1=-1+j:1:7-j
    if(i1>=0)
        for k1=i1*40+20-5:1:i1*40+20+5
            for k2=j*40+20-5:1:j*40+20+5
                if((k1-i1*40-20)^2+(k2-j*40-20)^2<25)
                bigMatrixImg(k2,k1,2)=1;
                end
            end
        end
end
end
 for i2=j:1:5-j     
     
     for k1=(7-j)*40+20-5:1:(7-j)*40+20+5
            for k2=(i2)*40+20-5:1:(i2)*40+20+5
                if((k1-(7-j)*40-20)^2+(k2-(i2)*40-20)^2<25)
                bigMatrixImg(k2,k1,2)=1;
                
            end
            end
        end     
 end
 for i3=7-j:-1:j
     for k1=(i3)*40+20-5:1:(i3)*40+20+5
            for k2=(5-j)*40+20-5:1:(5-j)*40+20+5
                if((k1-(i3)*40-20)^2+(k2-(5-j)*40-20)^2<25)
                bigMatrixImg(k2,k1,2)=1;
                
            end
                
            end
        end     
     
 end
 for i4=5-j:-1:2+j
      for k1=(j)*40+20-5:1:(j)*40+20+5
            for k2=(i4)*40+20-5:1:(i4)*40+20+5
                if((k1-(j)*40-20)^2+(k2-(i4)*40-20)^2<25)
                bigMatrixImg(k2,k1,2)=1;
                
            end
               
            end
        end      
     
    bigMatrixImg((j)*40+20,(i4)*40+20,2)=1;
     
 end
end
     


%pacman is moving inside
for j=0:1:2
for i1=-1+j:1:6-j
    Pacman(i1,j,i1+1,j);
end
 for i2=j:1:4-j
     Pacman(7-j,i2,7-j,i2+1);
 end
 for i3=7-j:-1:1+j
     Pacman(i3,5-j,i3-1,5-j);
 end
 for i4=5-j:-1:2+j
     Pacman(j,i4,j,i4-1);
 end
end


%pacman is moving outside
 for j=2:-1:0 
 for i4=2+j:1:5-j
     Pacman(j,i4-1,j,i4);
 end
for i3=1+j:1:7-j
     Pacman(i3-1,5-j,i3,5-j);
 end
 for i2=4-j:-1:j
     Pacman(7-j,i2+1,7-j,i2);
 end
 for i1=6-j:-1:-1+j
    Pacman(i1+1,j,i1,j);
end
end

aviobj = close(aviobj);